#ifndef COLOR_R05G06B05I_h
#define COLOR_R05G06B05I_h

/*!
 	@file
 	@brief	１ピクセルをあらわすクラス郡
\n			RGB565 フォーマット Ver.
 */
#include"../../Setup/CompileMode.h"
#include"../../Auxiliary/Macro.h"

#include"PixelConvertFunction.h"

namespace Maid
{
	/*!
	 	@class	COLOR_R05G06B05I COLOR_R05G06B05I.h
	 	@brief	アルファなし１６ビットピクセル
	 */
	class COLOR_R05G06B05I
	{
	public:
		COLOR_R05G06B05I(){}	//!<	コンストラクタ
		COLOR_R05G06B05I( unt08 a, unt08 r, unt08 g, unt08 b ){ SetRGB( r, g, b ); }	//!<	コンストラクタ
		template <class COLOR>
		COLOR_R05G06B05I( const COLOR& Col ){  SetRGB( Col.GetR(), Col.GetG(), Col.GetB() );  }	//!<	コンストラクタ


		unt08 GetA() const	{ return 0xFF;		}								//!<	アルファ成分の取得
		unt08 GetR() const	{ return PIXELCONVERT05_08((m_RGB&0xF800)>>11);	}	//!<	赤成分の取得
		unt08 GetG() const	{ return PIXELCONVERT06_08((m_RGB&0x07E0)>> 5);	}	//!<	緑成分の取得
		unt08 GetB() const	{ return PIXELCONVERT05_08((m_RGB&0x001F)>> 0);	}	//!<	青成分の取得

		operator unt16() const { return m_RGB; }	//!<	一括変換

		void SetA( unt08 a )	{ }	//!<	アルファ成分の設定
		void SetR( unt08 r )	{ m_RGB = (m_RGB&~0xF800) | (PIXELCONVERT08_05(r)<<11);	}	//!<	赤成分の設定
		void SetG( unt08 g )	{ m_RGB = (m_RGB&~0x07E0) | (PIXELCONVERT08_06(g)<< 5);	}	//!<	緑成分の設定
		void SetB( unt08 b )	{ m_RGB = (m_RGB&~0x001F) | (PIXELCONVERT08_05(b)<< 0);	}	//!<	青成分の設定

		void SetRGB( unt08 r, unt08 g, unt08 b )	//!<	いっきに設定
		{
			SetR( r );
			SetG( g );
			SetB( b );
		}

		//!	違うピクセルフォーマットとのコピー
		template <class PIXEL>
		COLOR_R05G06B05I& operator = (const PIXEL &src)
		{
			SetRGB(src.GetR(),src.GetG(),src.GetB());
			return *this;
		}

		//!	同じピクセルフォーマットとのコピー
		COLOR_R05G06B05I& operator = (const COLOR_R05G06B05I& src)
		{
			m_RGB = src.m_RGB;
			return *this;
		}

	private:
		unt16 m_RGB;
	};
}

#endif
